Index: apps/app_chanspy.c
===================================================================
RCS file: /usr/cvsroot/asterisk/apps/app_chanspy.c,v
retrieving revision 1.23
diff -u -u -r1.23 app_chanspy.c
--- apps/app_chanspy.c	14 Sep 2005 20:46:49 -0000	1.23
+++ apps/app_chanspy.c	30 Sep 2005 16:40:27 -0000
@@ -373,22 +373,21 @@
 	struct ast_channel_spy *cptr=NULL, *prev=NULL;
 	int count = 0;
 
-	while(ast_mutex_trylock(&chan->lock)) {
-		/* if its locked already it's almost surely hanging up and we are too late 
-		   we can safely remove the head pointer if it points at us without needing a lock.
-		   since everybody spying will be in the same boat whomever is pointing at the head
-		   will surely erase it which is all we really need since it's a linked list of
-		   staticly declared structs that belong to each spy.
-		*/
-		if (chan->spiers == spy) {
-			chan->spiers = NULL;
-			return;
-		}
-		count++;
-		if (count > 10) {
-			return;
-		}
-		sched_yield();
+
+	/* if its locked already it's almost surely hanging up and we are too late 
+	   we can safely remove the head pointer if it points at us without needing a lock.
+	   since everybody spying will be in the same boat whomever is pointing at the head
+	   will surely erase it which is all we really need since it's a linked list of
+	   staticly declared structs that belong to each spy.
+	*/
+
+	if (chan->spiers == spy) {
+		chan->spiers = spy->next;
+		return;
+	}
+
+	if(ast_mutex_trylock(&chan->lock)) {
+		return;
 	}
 
 	for(cptr=chan->spiers; cptr; cptr=cptr->next) {
